var app, express, fs, gzip, racer, store;
express = require('express');
gzip = require('connect-gzip');
fs = require('fs');
racer = require('racer');
app = express.createServer().use(express.favicon()).use(gzip.staticGzip(__dirname));
store = racer.createStore({
  redis: {
    db: 11
  },
  listen: app,
  namespace: 'pad'
});
store.flush();
racer.js({
  require: './node_modules/racer/node_modules/share/lib/types/helpers.js',
  minify: false,
  entry: __dirname + '/client.js'
}, function(js) {
  return fs.writeFileSync(__dirname + '/script.js', js);
});
app.get('/', function(req, res) {
  return res.redirect('/racer');
});
app.get('/:group', function(req, res) {
  var model;
  model = store.createModel();
  return model.subscribe({
    _room: "groups." + req.params.group
  }, function() {
    model.setNull('_room.text', model.ot('Edit this with friends.'));
    return model.bundle(function(bundle) {
      return res.send("<!DOCTYPE html>\n<title>Pad</title>\n<link rel=stylesheet href=style.css>\n<body>\n<div id=editor-container>\n  <textarea id=editor>" + (model.get('_room.text')) + "</textarea>\n</div>\n<script>init=" + bundle + "</script>\n<script src=script.js></script>");
    });
  });
});
app.listen(3011);
console.log('Go to http://localhost:3011/racer');