var Memory, MemorySync;
var __slice = Array.prototype.slice;
MemorySync = require('./MemorySync');
Memory = module.exports = function() {
  this._data = {
    world: {}
  };
  this._vers = {
    ver: 0
  };
};
Memory.prototype = {
  flush: function(callback) {
    this._data = {
      world: {}
    };
    this._vers = {
      ver: 0
    };
    return callback(null);
  },
  _get: MemorySync.prototype.getWithVersion,
  get: function(path, callback) {
    var val, ver, _ref;
    try {
      _ref = this._get(path), val = _ref[0], ver = _ref[1];
    } catch (err) {
      return callback(err);
    }
    return callback(null, val, ver);
  }
};
['set', 'del', 'push', 'unshift', 'splice', 'pop', 'shift', 'insertAfter', 'insertBefore', 'remove', 'move'].forEach(function(method) {
  var alias, fn;
  alias = '_' + method;
  Memory.prototype[alias] = fn = MemorySync.prototype[method];
  return Memory.prototype[method] = (function() {
    switch (fn.length) {
      case 3:
        return function(path, ver, callback) {
          try {
            this[alias](path, ver, null);
          } catch (err) {
            return callback(err);
          }
          return callback(null);
        };
      case 4:
        return function(path, arg0, ver, callback) {
          try {
            this[alias](path, arg0, ver, null);
          } catch (err) {
            return callback(err);
          }
          return callback(null, arg0);
        };
      case 5:
        return function(path, arg0, arg1, ver, callback) {
          try {
            this[alias](path, arg0, arg1, ver, null);
          } catch (err) {
            return callback(err);
          }
          return callback(null, arg0, arg1);
        };
      default:
        return function() {
          var args, callback, path, ver, _i;
          path = arguments[0], args = 4 <= arguments.length ? __slice.call(arguments, 1, _i = arguments.length - 2) : (_i = 1, []), ver = arguments[_i++], callback = arguments[_i++];
          try {
            this[alias].apply(this, [path].concat(__slice.call(args), [ver], [null]));
          } catch (err) {
            return callback(err);
          }
          return callback.apply(null, [null].concat(__slice.call(args)));
        };
    }
  })();
});